#pragma once

namespace ShowPicture {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

	using namespace System::IO; //  DirectoryInfo

	/// <summary>
	///   Form1
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form
	{
	public:
		Form1(void)
		{
			InitializeComponent();
			//
			//TODO:   
			//
			//  listBox1: 
			//       
			listBox1->Sorted = true; 
			//    " " 
			DirectoryInfo^ di; //  
			di = gcnew DirectoryInfo(Environment::GetFolderPath( 
				Environment::SpecialFolder::MyPictures));
			aPath = di->FullName; 
			label1->Text = aPath; 
			//       listBox 
			//   
			FillListBox(aPath);
		}

	protected:
		/// <summary>
		///    .
		/// </summary>
		~Form1()
		{
			if (components)
			{
				delete components;
			}
		}
	private: System::Windows::Forms::ListBox^  listBox1;
	protected: 
	private: System::Windows::Forms::PictureBox^  pictureBox1;
	private: System::Windows::Forms::Label^  label1;
	private: System::Windows::Forms::Button^  button1;

	private: String^ aPath; //    
	private: System::Windows::Forms::ToolTip^  toolTip1;
	private: System::ComponentModel::IContainer^  components;

	private:
		/// <summary>
		///   .
		/// </summary>


#pragma region Windows Form Designer generated code
		/// <summary>
		///      -  
		///       .
		/// </summary>
		void InitializeComponent(void)
		{
			this->components = (gcnew System::ComponentModel::Container());
			this->listBox1 = (gcnew System::Windows::Forms::ListBox());
			this->pictureBox1 = (gcnew System::Windows::Forms::PictureBox());
			this->label1 = (gcnew System::Windows::Forms::Label());
			this->button1 = (gcnew System::Windows::Forms::Button());
			this->toolTip1 = (gcnew System::Windows::Forms::ToolTip(this->components));
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->pictureBox1))->BeginInit();
			this->SuspendLayout();
			// 
			// listBox1
			// 
			this->listBox1->FormattingEnabled = true;
			this->listBox1->Location = System::Drawing::Point(12, 53);
			this->listBox1->Name = L"listBox1";
			this->listBox1->Size = System::Drawing::Size(157, 251);
			this->listBox1->TabIndex = 0;
			this->listBox1->SelectedIndexChanged += gcnew System::EventHandler(this, &Form1::listBox1_SelectedIndexChanged);
			// 
			// pictureBox1
			// 
			this->pictureBox1->Location = System::Drawing::Point(195, 53);
			this->pictureBox1->Name = L"pictureBox1";
			this->pictureBox1->Size = System::Drawing::Size(272, 251);
			this->pictureBox1->SizeMode = System::Windows::Forms::PictureBoxSizeMode::Zoom;
			this->pictureBox1->TabIndex = 1;
			this->pictureBox1->TabStop = false;
			// 
			// label1
			// 
			this->label1->AutoSize = true;
			this->label1->Location = System::Drawing::Point(9, 28);
			this->label1->Name = L"label1";
			this->label1->Size = System::Drawing::Size(35, 13);
			this->label1->TabIndex = 2;
			this->label1->Text = L"label1";
			// 
			// button1
			// 
			this->button1->Location = System::Drawing::Point(12, 310);
			this->button1->Name = L"button1";
			this->button1->Size = System::Drawing::Size(75, 23);
			this->button1->TabIndex = 3;
			this->button1->Text = L"...";
			this->toolTip1->SetToolTip(this->button1, L"   ");
			this->button1->UseVisualStyleBackColor = true;
			this->button1->Click += gcnew System::EventHandler(this, &Form1::button1_Click);
			// 
			// toolTip1
			// 
			this->toolTip1->IsBalloon = true;
			// 
			// Form1
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(485, 350);
			this->Controls->Add(this->button1);
			this->Controls->Add(this->label1);
			this->Controls->Add(this->pictureBox1);
			this->Controls->Add(this->listBox1);
			this->Name = L"Form1";
			this->Text = L" ";
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->pictureBox1))->EndInit();
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion
	private: System::Boolean FillListBox(String^ aPath)
	{
		//   
		DirectoryInfo^ di = gcnew DirectoryInfo(aPath);
		//   
		array<FileInfo^> ^fi = di->GetFiles("*.jpg");
		//   listBox1
		listBox1->Items->Clear();
		//   listBox1  jpg-,
		//    aPath
		for each (FileInfo^ fc in fi)
		{
			listBox1->Items->Add(fc->Name);
		}
		label1->Text = aPath;
		if (fi->Length == 0) return false;
		else
		{
			//      
			listBox1->SelectedIndex = 0;
			return true;
		}
	}

//    
private: System::Void button1_Click(System::Object^  sender, System::EventArgs^  e) {
	// FolderBrowserDialog    
	FolderBrowserDialog^ fb = gcnew FolderBrowserDialog();

	fb->Description = " ,\n" +
		"   ";
	fb->ShowNewFolderButton = false;
	fb->SelectedPath = aPath;
	//      ,
	//       
	if (fb->ShowDialog() == System::Windows::Forms::DialogResult::OK)
	{
		//        OK
		aPath = fb->SelectedPath;
		label1->Text = aPath;
		if (!FillListBox(fb->SelectedPath))
			//     
			pictureBox1->Image = nullptr;
	}
 }

//     
//       
//   
private: System::Void listBox1_SelectedIndexChanged(System::Object^  sender, System::EventArgs^  e) {
	pictureBox1->Visible = false;
	//    pictureBox1
	pictureBox1->Image = gcnew Bitmap(aPath + "\\" +
	listBox1->SelectedItem->ToString());
	if ((pictureBox1->Image->Width > pictureBox1->Size.Width) ||
		(pictureBox1->Image->Height > pictureBox1->Size.Height))
	{
		// 
		pictureBox1->SizeMode = PictureBoxSizeMode::Zoom;
	}
	else
	{
		//   
		pictureBox1->SizeMode = PictureBoxSizeMode::CenterImage;
	}
	pictureBox1->Visible = true;
}

};
}

